<template>
  <div class="base-recharge-level-container">
    <vab-query-form>
      <vab-query-form-left-panel :span="4">
        <el-button icon="el-icon-plus" type="primary" @click="handleEdit">
          {{ __('添加') }}
        </el-button>
      </vab-query-form-left-panel>
      <vab-query-form-right-panel :span="20">
        <el-button icon="el-icon-refresh" type="primary" @click="queryData">
          {{ __('刷新') }}
        </el-button>
      </vab-query-form-right-panel>
    </vab-query-form>

    <el-table
      v-loading="listLoading"
      border
      :data="list"
      :height="tableConfig.height"
    >
      <el-table-column align="center" :label="__('操作')" width="120">
        <template #default="{ row }">
          <el-button type="text" @click="handleEdit(row)">
            {{ __('编辑') }}
          </el-button>
          <el-button type="text" @click="handleDelete(row)">
            {{ __('删除') }}
          </el-button>
        </template>
      </el-table-column>
      <el-table-column
        align="center"
        :label="__('编号')"
        prop="recharge_level_id"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('额度名称')"
        prop="recharge_level_name"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('图片')"
        prop="recharge_level_img"
        show-overflow-tooltip
      >
        <template slot-scope="scope">
          <el-image
            v-show="scope.row.recharge_level_img"
            :preview-src-list="[scope.row.recharge_level_img]"
            :src="scope.row.recharge_level_img"
            style="width: 35px; height: 35px"
          />
        </template>
      </el-table-column>
      <el-table-column
        align="center"
        :label="__('充值额度')"
        prop="recharge_level_value"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('收益总额')"
        prop="recharge_level_gift"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :formatter="formatRepeat"
        :label="__('重复购买')"
        prop="recharge_level_repeat"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('有效时长/年')"
        prop="recharge_level_duration"
        show-overflow-tooltip
        width="100"
      />
      <el-table-column
        align="center"
        :label="__('描述')"
        prop="recharge_level_description"
        show-overflow-tooltip
        width="180"
      />
      <el-table-column
        align="center"
        :formatter="formatTime"
        :label="__('修改时间')"
        prop="recharge_level_time"
        show-overflow-tooltip
        width="180"
      />
    </el-table>
    <el-pagination
      background
      :current-page="queryForm.pageNum"
      :layout="layout"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange"
    />
    <edit ref="edit" @fetch-data="fetchData" />
  </div>
</template>

<script>
  import { translateTitle as __ } from '@/utils/i18n'
  import { doDelete, getList } from '@/api/base/recharge/level'
  import Edit from './components/BaseRechargeLevelEdit'
  import { renderTime } from '@/utils/date'

  export default {
    name: 'BaseRechargeLevel',
    components: { Edit },
    data() {
      return {
        tableConfig: {
          height: window.innerHeight - 220 - 90,
        },
        list: [],
        listLoading: true,
        layout: 'total, sizes, prev, pager, next, jumper',
        total: 0,
        selectRows: '',
        queryForm: {
          pageNum: 1,
          pageSize: 20,
        },
      }
    },
    created() {
      this.fetchData()
    },
    methods: {
      formatRepeat(row) {
        const repeat = row.recharge_level_repeat
        return repeat ? this.__('不限制') : this.__('购买一次')
      },
      __,
      handleEdit(row) {
        if (row.recharge_level_id) {
          this.$refs['edit'].showEdit(row)
        } else {
          this.$refs['edit'].showEdit()
        }
      },
      formatTime(row) {
        return renderTime(row.recharge_level_time)
      },
      handleDelete(row) {
        if (row.recharge_level_id) {
          this.$baseConfirm(this.__('你确定要删除当前项吗'), null, async () => {
            const { msg, status } = await doDelete({
              recharge_level_id: row.recharge_level_id,
            })
            if (200 == status) {
              this.$baseMessage(msg, 'success')
            } else {
              this.$baseMessage(msg, 'error')
            }
            await this.fetchData()
          })
        }
      },
      handleSizeChange(val) {
        this.queryForm.pageSize = val
        this.fetchData()
      },
      handleCurrentChange(val) {
        this.queryForm.pageNum = val
        this.fetchData()
      },
      queryData() {
        this.queryForm.pageNum = 1
        this.fetchData()
      },
      async fetchData() {
        this.listLoading = true
        const { data } = await getList(this.queryForm)
        this.list = data.items
        this.total = data.records
        this.listLoading = false
      },
    },
  }
</script>
